---
title: scroll-margin-inline-end
slug: Web/CSS/scroll-margin-inline-end
tags:
  - Advanced
  - CSS
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <code>scroll-margin-inline-end</code> property defines the margin of<span> the scroll snap area at the end of the inline dimension that is used for snapping this box to the snapport. The scroll snap area is determined by taking the transformed border box, finding its rectangular bounding box (axis-aligned in the scroll container’s coordinate space), then adding the specified outsets.</span></p>

<div>{{EmbedInteractiveExample("pages/css/scroll-margin-inline-end.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css notranslate">/* &lt;length&gt; values */
scroll-margin-inline-end: 10px;
scroll-margin-inline-end: 1em;

/* Global values */
scroll-margin-inline-end: inherit;
scroll-margin-inline-end: initial;
scroll-margin-inline-end: unset;
</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">&lt;length&gt;</span></font></dt>
 <dd>An outset from the inline end edge of the scroll container.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Simple_demonstration">Simple demonstration</h3>

<p>This example implements something very similar to the interactive example above, except that here we'll explain to you how it's implemented.</p>

<p>The aim here is to create four horizontally-scrolling blocks, the second and third of which snap into place, near but not quite at the right of each block.</p>

<h4 id="HTML">HTML</h4>

<p>The HTML that represents the blocks is very simple:</p>

<pre class="brush: html notranslate">&lt;div class="scroller"&gt;
  &lt;div&gt;1&lt;/div&gt;
  &lt;div&gt;2&lt;/div&gt;
  &lt;div&gt;3&lt;/div&gt;
  &lt;div&gt;4&lt;/div&gt;
&lt;/div&gt;</pre>

<h4 id="CSS">CSS</h4>

<p>Let's walk through the CSS. the outer container is styled like this:</p>

<pre class="brush: css notranslate">.scroller {
  text-align: left;
  width: 250px;
  height: 250px;
  overflow-x: scroll;
  display: flex;
  box-sizing: border-box;
  border: 1px solid #000;
  scroll-snap-type: x mandatory;
}</pre>

<p>The main parts relevant to the scroll snapping are <code><a href="/en-US/docs/Web/CSS/overflow-x">overflow-x</a>: scroll</code>, which makes sure the contents will scroll and not be hidden, and <code><a href="/en-US/docs/Web/CSS/scroll-snap-type">scroll-snap-type</a>: x mandatory</code>, which dictates that scroll snapping must occur along the horizontal axis, and the scrolling will always come to rest on a snap point.</p>

<p>The child elements are styled as follows:</p>

<pre class="brush: css notranslate">.scroller &gt; div {
  flex: 0 0 250px;
  width: 250px;
  background-color: #663399;
  color: #fff;
  font-size: 30px;
  display: flex;
  align-items: center;
  justify-content: center;
  scroll-snap-align: end;
}

.scroller &gt; div:nth-child(2n) {
  background-color: #fff;
  color: #663399;
}</pre>

<p>The most relevant part here is <code><a href="/en-US/docs/Web/CSS/scroll-snap-align">scroll-snap-align</a>: end</code>, which specifies that the right-hand edges (the "ends" along the x axis, in our case) are the designated snap points.</p>

<p>Last of all we specify the scroll margin values, a different one for the second and third child elements:</p>

<pre class="brush: css notranslate">.scroller &gt; div:nth-child(2) {
  scroll-margin-inline-end: 1rem;
}

.scroller &gt; div:nth-child(3) {
  scroll-margin-inline-end: 2rem;
}</pre>

<p>This means that when scrolling past the middle child elements, the scrolling will snap to <code>1rem</code> outside the inline end edge of the second <code>&lt;div&gt;</code>, and <code>2rems</code> outside the inline end edge of the third <code>&lt;div&gt;</code>.</p>

<h4 id="Result">Result</h4>

<p>Try it for yourself:</p>

<p>{{EmbedLiveSample('Simple_demonstration', '100%', 300)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Scroll Snap Points", "#propdef-scroll-margin-inline-end", "scroll-margin-inline-end")}}</td>
   <td>{{Spec2("CSS Scroll Snap Points")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("css.properties.scroll-margin-inline-end")}}</p>

<h2 id="See_also">See also</h2>

<ul>
  <li><a href="/en-US/docs/Web/CSS/CSS_Scroll_Snap">CSS Scroll Snap</a></li>
  <li><a href="https://developers.google.com/web/updates/2018/07/css-scroll-snap">Well-Controlled Scrolling with CSS Scroll Snap</a></li>
</ul>
